# reciper

A script to calculate recipe costs from concise recipe definition file.

## Usage

```sh
Usage:
reciper <recipe_file>
```

With the file `example/demo` as input :

```sh

# main targets
3 a
2 b

# definition for a
a
2 c
3 b

# definition for b
b
1 c

# no definition for c
```

The output is :

```sh
$ ./bin/reciper example/demo
# Steps
# 
# 3 a
# ├─6 c
# └─9 b
#   └─9 c
# 2 b
# └─2 c
# 
# Intermediaries
# 
# 3       a
# 11      b
# 
# Inputs
# 
# 17      c
# 
```

## Roadmap 🌠

- Ingredients sorted by depth
- Ingredients hash-colored
- Annotation for already available ingredients
    - Availability state passed along tree traversal
- Include library of definitions
    - Generate libraries of definitions from mc & Factorio
- Resolve multiple choice situations
    - avoid circular deps
    - interactive preference query for persistent recipe preference storage
- Annotation for one-time cost (recipe of production machine)
